﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Data.Entity;
using System.Windows.Forms;
using System.ComponentModel.DataAnnotations;

namespace bug62134
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            test1 tst = new test1();
            tst.SimpleConcurrencyCheck();
        }
    }

    public class Dog
    {
        [Key, DatabaseGenerated(DatabaseGeneratedOption.None)]
        public virtual int Id { get; set; }

        [DatabaseGenerated(DatabaseGeneratedOption.Computed)]
        public virtual DateTime Timestamp { get; set; }

        [ConcurrencyCheck, Required, MaxLength(45)]
        public virtual string Name { get; set; }
    }

    public class DogDBContext : DbContext
    {
        public DbSet<Dog> Dogs { get; set; }
    }

    public class test1
    {

        public void SimpleConcurrencyCheck()
        {
            using (var db = new DogDBContext())
            {
                db.Database.ExecuteSqlCommand(
    @"DROP TABLE IF EXISTS `test`.`dogs`");

                db.Database.ExecuteSqlCommand(
@"CREATE TABLE `dogs` (
  `Id` int(11) NOT NULL,
  `Name` varbinary(45) NOT NULL,
  `Timestamp` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`Id`)
) ENGINE=InnoDB DEFAULT CHARSET=binary");

                try
                {
                    var dog = db.Dogs.Create();
                    dog.Id = 1;
                    dog.Name = "Woofy";

                    db.Dogs.Add(dog);

                    db.SaveChanges();

                    dog.Name = "Sparky";

                    db.SaveChanges(); // Fails here with DB Update Exception
                }
                finally
                {
                    db.Database.ExecuteSqlCommand(@"DROP TABLE IF EXISTS `dogs`");
                }
            }
        }
    }
}
